{-# OPTIONS_GHC -w #-}
{-# OPTIONS -fglasgow-exts -cpp #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE TemplateHaskell            #-}


module Data.API.Parse
    ( parseAPI
    , parseAPIWithChangelog
    , api
    , apiWithChangelog
    ) where

import           Data.API.Types
import           Data.API.Scan
import           Data.API.Changes
import           Data.Char
import           Data.String
import qualified Data.Text                  as T
import qualified Data.CaseInsensitive       as CI
import qualified Data.Version               as V
import           Distribution.Text (simpleParse)
import           Language.Haskell.TH
import           Language.Haskell.TH.Quote
import           Text.Printf
import           Text.Regex
import qualified Data.Array as Happy_Data_Array
import qualified GHC.Exts as Happy_GHC_Exts
import Control.Applicative(Applicative(..))

-- parser produced by Happy Version 1.19.4

newtype HappyAbsSyn  = HappyAbsSyn HappyAny
#if __GLASGOW_HASKELL__ >= 607
type HappyAny = Happy_GHC_Exts.Any
#else
type HappyAny = forall a . a
#endif
happyIn5 :: (APIWithChangelog) -> (HappyAbsSyn )
happyIn5 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn5 #-}
happyOut5 :: (HappyAbsSyn ) -> (APIWithChangelog)
happyOut5 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut5 #-}
happyIn6 :: (API) -> (HappyAbsSyn )
happyIn6 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn ) -> (API)
happyOut6 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: ([Thing]) -> (HappyAbsSyn )
happyIn7 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn ) -> ([Thing])
happyOut7 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: (Thing) -> (HappyAbsSyn )
happyIn8 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn ) -> (Thing)
happyOut8 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: (APINode) -> (HappyAbsSyn )
happyIn9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn ) -> (APINode)
happyOut9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: (Spec) -> (HappyAbsSyn )
happyIn10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn ) -> (Spec)
happyOut10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: (Conversion) -> (HappyAbsSyn )
happyIn11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn ) -> (Conversion)
happyOut11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: (MDComment) -> (HappyAbsSyn )
happyIn12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn ) -> (MDComment)
happyOut12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: ([MDComment]) -> (HappyAbsSyn )
happyIn13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn ) -> ([MDComment])
happyOut13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: (Prefix) -> (HappyAbsSyn )
happyIn14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn ) -> (Prefix)
happyOut14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: (SpecRecord) -> (HappyAbsSyn )
happyIn15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn ) -> (SpecRecord)
happyOut15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyIn16 :: (SpecUnion) -> (HappyAbsSyn )
happyIn16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn16 #-}
happyOut16 :: (HappyAbsSyn ) -> (SpecUnion)
happyOut16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut16 #-}
happyIn17 :: ([(FieldName, FieldType)]) -> (HappyAbsSyn )
happyIn17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn17 #-}
happyOut17 :: (HappyAbsSyn ) -> ([(FieldName, FieldType)])
happyOut17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut17 #-}
happyIn18 :: (FieldType) -> (HappyAbsSyn )
happyIn18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn18 #-}
happyOut18 :: (HappyAbsSyn ) -> (FieldType)
happyOut18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut18 #-}
happyIn19 :: (Bool) -> (HappyAbsSyn )
happyIn19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn19 #-}
happyOut19 :: (HappyAbsSyn ) -> (Bool)
happyOut19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut19 #-}
happyIn20 :: ([(FieldName,(APIType,MDComment))]) -> (HappyAbsSyn )
happyIn20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn20 #-}
happyOut20 :: (HappyAbsSyn ) -> ([(FieldName,(APIType,MDComment))])
happyOut20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut20 #-}
happyIn21 :: (SpecEnum) -> (HappyAbsSyn )
happyIn21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn21 #-}
happyOut21 :: (HappyAbsSyn ) -> (SpecEnum)
happyOut21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut21 #-}
happyIn22 :: ([(FieldName,MDComment)]) -> (HappyAbsSyn )
happyIn22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn22 #-}
happyOut22 :: (HappyAbsSyn ) -> ([(FieldName,MDComment)])
happyOut22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut22 #-}
happyIn23 :: (SpecNewtype) -> (HappyAbsSyn )
happyIn23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn23 #-}
happyOut23 :: (HappyAbsSyn ) -> (SpecNewtype)
happyOut23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut23 #-}
happyIn24 :: (Maybe Filter) -> (HappyAbsSyn )
happyIn24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn24 #-}
happyOut24 :: (HappyAbsSyn ) -> (Maybe Filter)
happyOut24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut24 #-}
happyIn25 :: (Filter) -> (HappyAbsSyn )
happyIn25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn25 #-}
happyOut25 :: (HappyAbsSyn ) -> (Filter)
happyOut25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut25 #-}
happyIn26 :: (RegEx) -> (HappyAbsSyn )
happyIn26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn26 #-}
happyOut26 :: (HappyAbsSyn ) -> (RegEx)
happyOut26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut26 #-}
happyIn27 :: (APIType) -> (HappyAbsSyn )
happyIn27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn27 #-}
happyOut27 :: (HappyAbsSyn ) -> (APIType)
happyOut27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut27 #-}
happyIn28 :: (Maybe DefaultValue) -> (HappyAbsSyn )
happyIn28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn28 #-}
happyOut28 :: (HappyAbsSyn ) -> (Maybe DefaultValue)
happyOut28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut28 #-}
happyIn29 :: (BasicType) -> (HappyAbsSyn )
happyIn29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn29 #-}
happyOut29 :: (HappyAbsSyn ) -> (BasicType)
happyOut29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut29 #-}
happyIn30 :: (FieldName) -> (HappyAbsSyn )
happyIn30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn30 #-}
happyOut30 :: (HappyAbsSyn ) -> (FieldName)
happyOut30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut30 #-}
happyIn31 :: (String) -> (HappyAbsSyn )
happyIn31 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn31 #-}
happyOut31 :: (HappyAbsSyn ) -> (String)
happyOut31 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut31 #-}
happyIn32 :: (TypeName) -> (HappyAbsSyn )
happyIn32 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn32 #-}
happyOut32 :: (HappyAbsSyn ) -> (TypeName)
happyOut32 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut32 #-}
happyIn33 :: (APIChangelog) -> (HappyAbsSyn )
happyIn33 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn33 #-}
happyOut33 :: (HappyAbsSyn ) -> (APIChangelog)
happyOut33 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut33 #-}
happyIn34 :: (V.Version) -> (HappyAbsSyn )
happyIn34 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn34 #-}
happyOut34 :: (HappyAbsSyn ) -> (V.Version)
happyOut34 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut34 #-}
happyIn35 :: (VersionExtra) -> (HappyAbsSyn )
happyIn35 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn35 #-}
happyOut35 :: (HappyAbsSyn ) -> (VersionExtra)
happyOut35 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut35 #-}
happyIn36 :: ([APIChange]) -> (HappyAbsSyn )
happyIn36 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn36 #-}
happyOut36 :: (HappyAbsSyn ) -> ([APIChange])
happyOut36 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut36 #-}
happyIn37 :: ([[APIChange]]) -> (HappyAbsSyn )
happyIn37 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn37 #-}
happyOut37 :: (HappyAbsSyn ) -> ([[APIChange]])
happyOut37 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut37 #-}
happyIn38 :: ([APIChange]) -> (HappyAbsSyn )
happyIn38 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn38 #-}
happyOut38 :: (HappyAbsSyn ) -> ([APIChange])
happyOut38 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut38 #-}
happyIn39 :: ([FieldChange]) -> (HappyAbsSyn )
happyIn39 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn39 #-}
happyOut39 :: (HappyAbsSyn ) -> ([FieldChange])
happyOut39 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut39 #-}
happyIn40 :: ([FieldChange]) -> (HappyAbsSyn )
happyIn40 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn40 #-}
happyOut40 :: (HappyAbsSyn ) -> ([FieldChange])
happyOut40 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut40 #-}
happyIn41 :: (Maybe DefaultValue) -> (HappyAbsSyn )
happyIn41 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn41 #-}
happyOut41 :: (HappyAbsSyn ) -> (Maybe DefaultValue)
happyOut41 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut41 #-}
happyIn42 :: (DefaultValue) -> (HappyAbsSyn )
happyIn42 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn42 #-}
happyOut42 :: (HappyAbsSyn ) -> (DefaultValue)
happyOut42 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut42 #-}
happyIn43 :: ([UnionChange]) -> (HappyAbsSyn )
happyIn43 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn43 #-}
happyOut43 :: (HappyAbsSyn ) -> ([UnionChange])
happyOut43 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut43 #-}
happyIn44 :: ([UnionChange]) -> (HappyAbsSyn )
happyIn44 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn44 #-}
happyOut44 :: (HappyAbsSyn ) -> ([UnionChange])
happyOut44 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut44 #-}
happyIn45 :: ([EnumChange]) -> (HappyAbsSyn )
happyIn45 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn45 #-}
happyOut45 :: (HappyAbsSyn ) -> ([EnumChange])
happyOut45 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut45 #-}
happyIn46 :: ([EnumChange]) -> (HappyAbsSyn )
happyIn46 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn46 #-}
happyOut46 :: (HappyAbsSyn ) -> ([EnumChange])
happyOut46 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut46 #-}
happyIn47 :: (MigrationTag) -> (HappyAbsSyn )
happyIn47 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn47 #-}
happyOut47 :: (HappyAbsSyn ) -> (MigrationTag)
happyOut47 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut47 #-}
happyInTok :: (PToken) -> (HappyAbsSyn )
happyInTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn ) -> (PToken)
happyOutTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOutTok #-}


happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x00\x00\x00\x00\x00\x00\xf8\x00\x0c\x01\xe5\x00\xe5\x00\x47\x00\x01\x01\x08\x01\xe7\x00\x00\x00\xe4\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe3\x00\x00\x00\x00\x00\xdd\x00\x00\x00\xf9\x00\x00\x00\x02\x01\x3a\x00\x00\x00\xfc\x00\x00\x00\xe2\x00\xe2\x00\xe2\x00\x6e\x00\xf2\xff\x00\x00\xf4\x00\x00\x00\x00\x00\xdc\x00\x00\x00\xdc\x00\xdc\x00\xdc\x00\xe1\x00\x00\x00\x00\x00\xff\xff\xff\xff\xf2\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x26\x00\x26\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x47\x00\xfb\x00\xfa\x00\x60\x00\x00\x00\x00\x00\xd7\x00\x43\x00\x3c\x00\xfd\xff\xd6\x00\x00\x00\xfd\xff\x00\x00\x50\x00\x00\x00\x3c\x00\x00\x00\x66\x00\x00\x00\x1f\x00\x00\x00\x63\x00\x00\x00\x00\x00\xf7\x00\xf6\x00\x47\x00\xf5\x00\x47\x00\x47\x00\xf1\x00\x00\x00\x00\x00\xf0\x00\x00\x00\x47\x00\xed\x00\x00\x00\x26\x00\xee\x00\xec\x00\x47\x00\x00\x00\x47\x00\x00\x00\xfa\xff\x47\x00\x47\x00\x47\x00\x00\x00\x47\x00\x47\x00\x47\x00\x00\x00\x47\x00\x47\x00\x47\x00\x47\x00\x00\x00\xeb\x00\xd2\x00\x00\x00\xea\x00\xce\x00\x00\x00\xe8\x00\xcc\x00\x00\x00\x00\x00\x00\x00\x00\x00\x4d\x00\x4c\x00\x00\x00\x00\x00\x00\x00\xe6\x00\x26\x00\x26\x00\x00\x00\xc8\x00\x47\x00\x00\x00\xfe\xff\x00\x00\x00\x00\x00\x00\x26\x00\x00\x00\xe0\x00\xdf\x00\x00\x00\x00\x00\x47\x00\x26\x00\x47\x00\x26\x00\x47\x00\x26\x00\xc7\x00\x00\x00\xc9\x00\x00\x00\x00\x00\x00\x00\xdb\x00\xda\x00\x00\x00\x00\x00\x00\x00\x00\x00\xde\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xbb\x00\xb6\x00\x00\x00\xfe\xff\xc5\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\xd1\x00\x78\x00\xcf\x00\x00\x00\x00\x00\x00\x00\x00\x00\x14\x00\x28\x00\x00\x00\x00\x00\x00\x00\xb1\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xac\x00\x00\x00\x00\x00\x23\x00\x00\x00\x00\x00\xba\x00\xc0\x00\x00\x00\x00\x00\xc4\x00\xc3\x00\xc2\x00\x00\x00\xad\x00\x00\x00\x02\x00\x00\x00\x00\x00\xc1\x00\x00\x00\xbf\x00\xbe\x00\xbd\x00\x00\x00\x00\x00\x00\x00\x46\x00\x36\x00\xd0\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7a\x00\x77\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\xc6\x00\x99\x00\xbc\x00\x00\x00\x00\x00\x76\x00\x9d\x00\xa3\x00\xa1\x00\x69\x00\x00\x00\xaa\x00\x00\x00\x00\x00\x00\x00\x67\x00\x00\x00\x00\x00\x00\x00\x5b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x48\x00\x00\x00\xa8\x00\x00\x00\xa6\x00\xa4\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa2\x00\x00\x00\x00\x00\x4a\x00\x00\x00\x00\x00\xa0\x00\xb0\x00\x9c\x00\x00\x00\x9f\x00\x98\x00\x96\x00\x94\x00\x00\x00\x92\x00\x8f\x00\x8d\x00\x00\x00\x8b\x00\x89\x00\x87\x00\x85\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x95\x00\x00\x00\x00\x00\x74\x00\x2f\x00\x00\x00\x35\x00\x81\x00\x00\x00\xf4\xff\x00\x00\x00\x00\x91\x00\x73\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7d\x00\x70\x00\x7b\x00\x6f\x00\xee\xff\x37\x00\x00\x00\x00\x00\x25\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x6d\x00\x00\x00\x2a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x19\x00\xf8\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\xfa\xff\xfa\xff\x00\x00\x00\x00\xfc\xff\x00\x00\x00\x00\xed\xff\xed\xff\x00\x00\xef\xff\xfd\xff\x00\x00\xfb\xff\xf9\xff\xf8\xff\x00\x00\xec\xff\xc6\xff\xc5\xff\xc4\xff\xc3\xff\xc7\xff\x00\x00\xc0\xff\xba\xff\xbd\xff\xee\xff\xed\xff\xbf\xff\x00\x00\xbc\xff\xed\xff\x00\x00\xbb\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb1\xff\xed\xff\xc1\xff\xb2\xff\x00\x00\x94\xff\x00\x00\x00\x00\x00\x00\x00\x00\xc2\xff\xb8\xff\x00\x00\x00\x00\xf0\xff\xf6\xff\xf5\xff\xf4\xff\xf3\xff\xf2\xff\xd1\xff\x00\x00\x00\x00\xca\xff\xcb\xff\xc9\xff\xcd\xff\xcc\xff\xd0\xff\x00\x00\x00\x00\x00\x00\x00\x00\xd2\xff\xb9\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb3\xff\xb6\xff\xaf\xff\x00\x00\xaa\xff\xb5\xff\x9f\xff\x00\x00\x9b\xff\xb4\xff\x99\xff\x00\x00\x95\xff\xb7\xff\xdd\xff\xe2\xff\x00\x00\xea\xff\x00\x00\xeb\xff\x00\x00\xc8\xff\xd4\xff\x00\x00\xf7\xff\x00\x00\x00\x00\xd3\xff\x00\x00\x00\x00\x00\x00\x00\x00\xed\xff\x00\x00\xdf\xff\x00\x00\x00\x00\x00\x00\x00\x00\x9a\xff\x00\x00\x00\x00\x00\x00\xa0\xff\x00\x00\x00\x00\x00\x00\x00\x00\xb0\xff\x00\x00\x00\x00\xad\xff\x00\x00\x00\x00\x9d\xff\x00\x00\x00\x00\x97\xff\x98\xff\xde\xff\xdc\xff\x00\x00\x00\x00\xd5\xff\xed\xff\xe0\xff\x00\x00\x00\x00\x00\x00\xe8\xff\xe5\xff\x00\x00\xf1\xff\xce\xff\xe6\xff\xe9\xff\xed\xff\x00\x00\xe1\xff\xdb\xff\xd8\xff\xd9\xff\xd6\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xac\xff\xa8\xff\x9c\xff\x9e\xff\x96\xff\x00\x00\x00\x00\xed\xff\xe3\xff\xed\xff\xcf\xff\x00\x00\xa6\xff\xa2\xff\xa5\xff\xa4\xff\xa3\xff\xa1\xff\xa7\xff\xe7\xff\xe4\xff\x00\x00\x00\x00\xae\xff\x00\x00\x00\x00\xab\xff\xa9\xff\xd7\xff\xda\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x03\x00\x03\x00\x09\x00\x0a\x00\x13\x00\x07\x00\x19\x00\x1a\x00\x07\x00\x08\x00\x17\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x24\x00\x03\x00\x04\x00\x25\x00\x1d\x00\x07\x00\x08\x00\x09\x00\x1c\x00\x21\x00\x23\x00\x27\x00\x2a\x00\x24\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x03\x00\x07\x00\x08\x00\x0c\x00\x07\x00\x1a\x00\x07\x00\x08\x00\x07\x00\x08\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x19\x00\x1a\x00\x05\x00\x0d\x00\x1e\x00\x25\x00\x1c\x00\x0a\x00\x0b\x00\x23\x00\x0e\x00\x1c\x00\x16\x00\x10\x00\x18\x00\x12\x00\x24\x00\x24\x00\x05\x00\x16\x00\x16\x00\x18\x00\x18\x00\x0a\x00\x0b\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x10\x00\x0d\x00\x12\x00\x1f\x00\x1e\x00\x13\x00\x16\x00\x23\x00\x18\x00\x23\x00\x16\x00\x1e\x00\x18\x00\x1c\x00\x1d\x00\x1e\x00\x23\x00\x20\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x25\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x26\x00\x26\x00\x07\x00\x08\x00\x2a\x00\x2a\x00\x00\x00\x01\x00\x02\x00\x18\x00\x19\x00\x1a\x00\x18\x00\x19\x00\x1a\x00\x13\x00\x14\x00\x15\x00\x29\x00\x16\x00\x16\x00\x18\x00\x18\x00\x16\x00\x16\x00\x18\x00\x18\x00\x16\x00\x27\x00\x18\x00\x16\x00\x1b\x00\x18\x00\x2a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x07\x00\x08\x00\x19\x00\x1a\x00\x07\x00\x08\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x11\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x14\x00\x15\x00\x19\x00\x1a\x00\x07\x00\x08\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x19\x00\x1a\x00\x22\x00\x23\x00\x28\x00\x29\x00\x07\x00\x08\x00\x26\x00\x27\x00\x1f\x00\x20\x00\x23\x00\x1d\x00\x1e\x00\x01\x00\x02\x00\x01\x00\x02\x00\x18\x00\x0f\x00\x06\x00\x2a\x00\x1b\x00\x1b\x00\x1b\x00\x21\x00\x1b\x00\x1b\x00\x1b\x00\x1b\x00\x2a\x00\x26\x00\x04\x00\x09\x00\x09\x00\x1c\x00\x1f\x00\x08\x00\x08\x00\x24\x00\x22\x00\x05\x00\x20\x00\x05\x00\x20\x00\x05\x00\x05\x00\x05\x00\x20\x00\x05\x00\x04\x00\x08\x00\x05\x00\x02\x00\x02\x00\x02\x00\x24\x00\x24\x00\x02\x00\x02\x00\x0c\x00\x0b\x00\x24\x00\x20\x00\x06\x00\x01\x00\x0b\x00\x05\x00\x24\x00\x24\x00\x2b\x00\x01\x00\x23\x00\x27\x00\x0b\x00\x01\x00\xff\xff\x17\x00\x2b\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\xb6\x00\x3e\x00\x8e\x00\x8f\x00\x2d\x00\x3f\x00\xaa\x00\x65\x00\x09\x00\x0a\x00\xb3\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x46\x00\x47\x00\x48\x00\x49\x00\x2e\x00\x0d\x00\x0e\x00\xb4\x00\x54\x00\x0f\x00\x0a\x00\x10\x00\x2a\x00\xb7\x00\x55\x00\x90\x00\xc4\x00\x4a\x00\xb8\x00\xb9\x00\xba\x00\xbb\x00\xbc\x00\x3e\x00\x09\x00\x0a\x00\x63\x00\x3f\x00\x11\x00\x09\x00\x0a\x00\xbd\x00\x0a\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\x45\x00\x64\x00\x65\x00\x36\x00\x9b\x00\x5c\x00\xc5\x00\x1d\x00\x37\x00\x38\x00\x5d\x00\x99\x00\x0b\x00\x96\x00\x39\x00\x3c\x00\x3a\x00\xc1\x00\x4a\x00\x4a\x00\x3b\x00\xa9\x00\x3c\x00\x3c\x00\x37\x00\x38\x00\x24\x00\x25\x00\x26\x00\x27\x00\x39\x00\x95\x00\x3a\x00\x28\x00\x58\x00\x72\x00\x3b\x00\x29\x00\x3c\x00\x59\x00\x96\x00\x5c\x00\x3c\x00\x13\x00\x14\x00\x15\x00\x5d\x00\x16\x00\x7d\x00\x7e\x00\x7f\x00\x80\x00\x17\x00\x40\x00\x41\x00\x42\x00\x43\x00\x44\x00\xa0\x00\xa2\x00\xbe\x00\x0a\x00\xa1\x00\xa3\x00\x05\x00\x03\x00\x04\x00\x75\x00\x76\x00\x77\x00\x79\x00\x7a\x00\x7b\x00\x2f\x00\x30\x00\x31\x00\x77\x00\xab\x00\xad\x00\x3c\x00\x3c\x00\xb1\x00\x9c\x00\x3c\x00\x3c\x00\x66\x00\x7b\x00\x3c\x00\x67\x00\x5d\x00\x3c\x00\x50\x00\xac\x00\x65\x00\xae\x00\x65\x00\xb2\x00\x0a\x00\x98\x00\x65\x00\x9e\x00\x0a\x00\x81\x00\x65\x00\x82\x00\x65\x00\x83\x00\x65\x00\x84\x00\x65\x00\x85\x00\x65\x00\x86\x00\x65\x00\x5f\x00\x87\x00\x65\x00\x88\x00\x65\x00\x89\x00\x65\x00\x8a\x00\x65\x00\x8b\x00\x8c\x00\x90\x00\x65\x00\x91\x00\x0a\x00\x92\x00\x65\x00\x6a\x00\x65\x00\x6d\x00\x65\x00\x6e\x00\x65\x00\x70\x00\x65\x00\x51\x00\x52\x00\x59\x00\x5a\x00\x21\x00\x0a\x00\x55\x00\x56\x00\x1e\x00\x1f\x00\x80\x00\x18\x00\x19\x00\x03\x00\x04\x00\x06\x00\x04\x00\x5e\x00\x61\x00\x68\x00\x2b\x00\x4c\x00\x4d\x00\x4e\x00\x22\x00\x4f\x00\x31\x00\x33\x00\x34\x00\xc7\x00\xc8\x00\xbd\x00\xc0\x00\xc1\x00\xc3\x00\xc4\x00\xb0\x00\xb1\x00\x2e\x00\x9b\x00\x9e\x00\xa4\x00\xa5\x00\xa6\x00\xa7\x00\xa9\x00\x94\x00\xa8\x00\x95\x00\x6c\x00\x98\x00\x6d\x00\x70\x00\x72\x00\x74\x00\x2e\x00\x33\x00\x61\x00\x63\x00\x6a\x00\x0d\x00\x33\x00\x4c\x00\x36\x00\x2a\x00\x0d\x00\x18\x00\x33\x00\x21\x00\xbe\xff\x1d\x00\x1c\x00\x1b\x00\x0d\x00\x08\x00\x00\x00\x09\x00\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = Happy_Data_Array.array (2, 107) [
	(2 , happyReduce_2),
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38),
	(39 , happyReduce_39),
	(40 , happyReduce_40),
	(41 , happyReduce_41),
	(42 , happyReduce_42),
	(43 , happyReduce_43),
	(44 , happyReduce_44),
	(45 , happyReduce_45),
	(46 , happyReduce_46),
	(47 , happyReduce_47),
	(48 , happyReduce_48),
	(49 , happyReduce_49),
	(50 , happyReduce_50),
	(51 , happyReduce_51),
	(52 , happyReduce_52),
	(53 , happyReduce_53),
	(54 , happyReduce_54),
	(55 , happyReduce_55),
	(56 , happyReduce_56),
	(57 , happyReduce_57),
	(58 , happyReduce_58),
	(59 , happyReduce_59),
	(60 , happyReduce_60),
	(61 , happyReduce_61),
	(62 , happyReduce_62),
	(63 , happyReduce_63),
	(64 , happyReduce_64),
	(65 , happyReduce_65),
	(66 , happyReduce_66),
	(67 , happyReduce_67),
	(68 , happyReduce_68),
	(69 , happyReduce_69),
	(70 , happyReduce_70),
	(71 , happyReduce_71),
	(72 , happyReduce_72),
	(73 , happyReduce_73),
	(74 , happyReduce_74),
	(75 , happyReduce_75),
	(76 , happyReduce_76),
	(77 , happyReduce_77),
	(78 , happyReduce_78),
	(79 , happyReduce_79),
	(80 , happyReduce_80),
	(81 , happyReduce_81),
	(82 , happyReduce_82),
	(83 , happyReduce_83),
	(84 , happyReduce_84),
	(85 , happyReduce_85),
	(86 , happyReduce_86),
	(87 , happyReduce_87),
	(88 , happyReduce_88),
	(89 , happyReduce_89),
	(90 , happyReduce_90),
	(91 , happyReduce_91),
	(92 , happyReduce_92),
	(93 , happyReduce_93),
	(94 , happyReduce_94),
	(95 , happyReduce_95),
	(96 , happyReduce_96),
	(97 , happyReduce_97),
	(98 , happyReduce_98),
	(99 , happyReduce_99),
	(100 , happyReduce_100),
	(101 , happyReduce_101),
	(102 , happyReduce_102),
	(103 , happyReduce_103),
	(104 , happyReduce_104),
	(105 , happyReduce_105),
	(106 , happyReduce_106),
	(107 , happyReduce_107)
	]

happy_n_terms = 44 :: Int
happy_n_nonterms = 43 :: Int

happyReduce_2 = happySpecReduce_3  0# happyReduction_2
happyReduction_2 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut6 happy_x_1 of { happy_var_1 -> 
	case happyOut33 happy_x_3 of { happy_var_3 -> 
	happyIn5
		 ((happy_var_1, happy_var_3)
	)}}

happyReduce_3 = happySpecReduce_1  1# happyReduction_3
happyReduction_3 happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	happyIn6
		 (reverse happy_var_1
	)}

happyReduce_4 = happySpecReduce_3  2# happyReduction_4
happyReduction_4 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	case happyOut8 happy_x_3 of { happy_var_3 -> 
	happyIn7
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_5 = happySpecReduce_0  2# happyReduction_5
happyReduction_5  =  happyIn7
		 ([]
	)

happyReduce_6 = happySpecReduce_1  3# happyReduction_6
happyReduction_6 happy_x_1
	 =  case happyOut9 happy_x_1 of { happy_var_1 -> 
	happyIn8
		 (ThNode    happy_var_1
	)}

happyReduce_7 = happySpecReduce_1  3# happyReduction_7
happyReduction_7 happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	happyIn8
		 (ThComment happy_var_1
	)}

happyReduce_8 = happyReduce 7# 4# happyReduction_8
happyReduction_8 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut14 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { ((,) _ (TypeIden happy_var_3)) -> 
	case happyOut12 happy_x_4 of { happy_var_4 -> 
	case happyOut10 happy_x_6 of { happy_var_6 -> 
	case happyOut11 happy_x_7 of { happy_var_7 -> 
	happyIn9
		 (APINode (TypeName happy_var_3) happy_var_4 happy_var_1 happy_var_6 happy_var_7
	) `HappyStk` happyRest}}}}}

happyReduce_9 = happySpecReduce_1  5# happyReduction_9
happyReduction_9 happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	happyIn10
		 (SpRecord  happy_var_1
	)}

happyReduce_10 = happySpecReduce_1  5# happyReduction_10
happyReduction_10 happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	happyIn10
		 (SpUnion   happy_var_1
	)}

happyReduce_11 = happySpecReduce_1  5# happyReduction_11
happyReduction_11 happy_x_1
	 =  case happyOut21 happy_x_1 of { happy_var_1 -> 
	happyIn10
		 (SpEnum    happy_var_1
	)}

happyReduce_12 = happySpecReduce_1  5# happyReduction_12
happyReduction_12 happy_x_1
	 =  case happyOut23 happy_x_1 of { happy_var_1 -> 
	happyIn10
		 (SpNewtype happy_var_1
	)}

happyReduce_13 = happySpecReduce_1  5# happyReduction_13
happyReduction_13 happy_x_1
	 =  case happyOut27 happy_x_1 of { happy_var_1 -> 
	happyIn10
		 (SpSynonym happy_var_1
	)}

happyReduce_14 = happyReduce 4# 6# happyReduction_14
happyReduction_14 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut30 happy_x_2 of { happy_var_2 -> 
	case happyOut30 happy_x_4 of { happy_var_4 -> 
	happyIn11
		 (Just (happy_var_2,happy_var_4)
	) `HappyStk` happyRest}}

happyReduce_15 = happySpecReduce_0  6# happyReduction_15
happyReduction_15  =  happyIn11
		 (Nothing
	)

happyReduce_16 = happySpecReduce_1  7# happyReduction_16
happyReduction_16 happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	happyIn12
		 (unlines $ reverse happy_var_1
	)}

happyReduce_17 = happySpecReduce_2  8# happyReduction_17
happyReduction_17 happy_x_2
	happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { ((,) _ (Comment  happy_var_2)) -> 
	happyIn13
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_18 = happySpecReduce_0  8# happyReduction_18
happyReduction_18  =  happyIn13
		 ([]
	)

happyReduce_19 = happySpecReduce_1  9# happyReduction_19
happyReduction_19 happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (CI.mk happy_var_1
	)}

happyReduce_20 = happySpecReduce_2  10# happyReduction_20
happyReduction_20 happy_x_2
	happy_x_1
	 =  case happyOut17 happy_x_2 of { happy_var_2 -> 
	happyIn15
		 (SpecRecord $ reverse happy_var_2
	)}

happyReduce_21 = happySpecReduce_2  11# happyReduction_21
happyReduction_21 happy_x_2
	happy_x_1
	 =  case happyOut20 happy_x_2 of { happy_var_2 -> 
	happyIn16
		 (SpecUnion  $ reverse happy_var_2
	)}

happyReduce_22 = happyReduce 4# 12# happyReduction_22
happyReduction_22 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_1 of { happy_var_1 -> 
	case happyOut30 happy_x_2 of { happy_var_2 -> 
	case happyOut18 happy_x_4 of { happy_var_4 -> 
	happyIn17
		 ((happy_var_2,happy_var_4) : happy_var_1
	) `HappyStk` happyRest}}}

happyReduce_23 = happySpecReduce_3  12# happyReduction_23
happyReduction_23 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	case happyOut18 happy_x_3 of { happy_var_3 -> 
	happyIn17
		 ([(happy_var_1,happy_var_3)]
	)}}

happyReduce_24 = happyReduce 4# 13# happyReduction_24
happyReduction_24 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut27 happy_x_1 of { happy_var_1 -> 
	case happyOut19 happy_x_2 of { happy_var_2 -> 
	case happyOut28 happy_x_3 of { happy_var_3 -> 
	case happyOut12 happy_x_4 of { happy_var_4 -> 
	happyIn18
		 (FieldType happy_var_1 happy_var_2 happy_var_3 happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_25 = happySpecReduce_1  14# happyReduction_25
happyReduction_25 happy_x_1
	 =  happyIn19
		 (True
	)

happyReduce_26 = happySpecReduce_0  14# happyReduction_26
happyReduction_26  =  happyIn19
		 (False
	)

happyReduce_27 = happyReduce 6# 15# happyReduction_27
happyReduction_27 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut20 happy_x_1 of { happy_var_1 -> 
	case happyOut30 happy_x_3 of { happy_var_3 -> 
	case happyOut27 happy_x_5 of { happy_var_5 -> 
	case happyOut12 happy_x_6 of { happy_var_6 -> 
	happyIn20
		 ((happy_var_3,(happy_var_5,happy_var_6)) : happy_var_1
	) `HappyStk` happyRest}}}}

happyReduce_28 = happyReduce 5# 15# happyReduction_28
happyReduction_28 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut30 happy_x_2 of { happy_var_2 -> 
	case happyOut27 happy_x_4 of { happy_var_4 -> 
	case happyOut12 happy_x_5 of { happy_var_5 -> 
	happyIn20
		 ([(happy_var_2,(happy_var_4,happy_var_5))]
	) `HappyStk` happyRest}}}

happyReduce_29 = happySpecReduce_2  16# happyReduction_29
happyReduction_29 happy_x_2
	happy_x_1
	 =  case happyOut22 happy_x_2 of { happy_var_2 -> 
	happyIn21
		 (SpecEnum $ reverse happy_var_2
	)}

happyReduce_30 = happyReduce 4# 17# happyReduction_30
happyReduction_30 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut22 happy_x_1 of { happy_var_1 -> 
	case happyOut30 happy_x_3 of { happy_var_3 -> 
	case happyOut12 happy_x_4 of { happy_var_4 -> 
	happyIn22
		 ((happy_var_3,happy_var_4) : happy_var_1
	) `HappyStk` happyRest}}}

happyReduce_31 = happySpecReduce_3  17# happyReduction_31
happyReduction_31 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_2 of { happy_var_2 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 ([(happy_var_2,happy_var_3)]
	)}}

happyReduce_32 = happySpecReduce_3  18# happyReduction_32
happyReduction_32 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_2 of { happy_var_2 -> 
	case happyOut24 happy_x_3 of { happy_var_3 -> 
	happyIn23
		 (SpecNewtype happy_var_2 happy_var_3
	)}}

happyReduce_33 = happySpecReduce_2  19# happyReduction_33
happyReduction_33 happy_x_2
	happy_x_1
	 =  case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn24
		 (Just happy_var_2
	)}

happyReduce_34 = happySpecReduce_0  19# happyReduction_34
happyReduction_34  =  happyIn24
		 (Nothing
	)

happyReduce_35 = happySpecReduce_1  20# happyReduction_35
happyReduction_35 happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	happyIn25
		 (FtrStrg happy_var_1
	)}

happyReduce_36 = happySpecReduce_2  20# happyReduction_36
happyReduction_36 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { ((,) _ (Intg     happy_var_2)) -> 
	happyIn25
		 (FtrIntg $ IntRange (Just happy_var_2) Nothing
	)}

happyReduce_37 = happyReduce 5# 20# happyReduction_37
happyReduction_37 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { ((,) _ (Intg     happy_var_2)) -> 
	case happyOutTok happy_x_5 of { ((,) _ (Intg     happy_var_5)) -> 
	happyIn25
		 (FtrIntg $ IntRange (Just happy_var_2) (Just happy_var_5)
	) `HappyStk` happyRest}}

happyReduce_38 = happySpecReduce_2  20# happyReduction_38
happyReduction_38 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { ((,) _ (Intg     happy_var_2)) -> 
	happyIn25
		 (FtrIntg $ IntRange Nothing   (Just happy_var_2)
	)}

happyReduce_39 = happySpecReduce_2  20# happyReduction_39
happyReduction_39 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { ((,) _ (UTCTIME  happy_var_2)) -> 
	happyIn25
		 (FtrUTC  $ UTCRange (Just happy_var_2) Nothing
	)}

happyReduce_40 = happyReduce 5# 20# happyReduction_40
happyReduction_40 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { ((,) _ (UTCTIME  happy_var_2)) -> 
	case happyOutTok happy_x_5 of { ((,) _ (UTCTIME  happy_var_5)) -> 
	happyIn25
		 (FtrUTC  $ UTCRange (Just happy_var_2) (Just happy_var_5)
	) `HappyStk` happyRest}}

happyReduce_41 = happySpecReduce_2  20# happyReduction_41
happyReduction_41 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { ((,) _ (UTCTIME  happy_var_2)) -> 
	happyIn25
		 (FtrUTC  $ UTCRange Nothing   (Just happy_var_2)
	)}

happyReduce_42 = happySpecReduce_1  21# happyReduction_42
happyReduction_42 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (Strg     happy_var_1)) -> 
	happyIn26
		 (RegEx (T.pack happy_var_1) $ mkRegexWithOpts happy_var_1 False True
	)}

happyReduce_43 = happySpecReduce_2  22# happyReduction_43
happyReduction_43 happy_x_2
	happy_x_1
	 =  case happyOut27 happy_x_2 of { happy_var_2 -> 
	happyIn27
		 (TyMaybe            happy_var_2
	)}

happyReduce_44 = happySpecReduce_3  22# happyReduction_44
happyReduction_44 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut27 happy_x_2 of { happy_var_2 -> 
	happyIn27
		 (TyList             happy_var_2
	)}

happyReduce_45 = happySpecReduce_1  22# happyReduction_45
happyReduction_45 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (TypeIden happy_var_1)) -> 
	happyIn27
		 (TyName   (TypeName happy_var_1)
	)}

happyReduce_46 = happySpecReduce_1  22# happyReduction_46
happyReduction_46 happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	happyIn27
		 (TyBasic            happy_var_1
	)}

happyReduce_47 = happySpecReduce_1  22# happyReduction_47
happyReduction_47 happy_x_1
	 =  happyIn27
		 (TyJSON
	)

happyReduce_48 = happySpecReduce_1  23# happyReduction_48
happyReduction_48 happy_x_1
	 =  case happyOut42 happy_x_1 of { happy_var_1 -> 
	happyIn28
		 (Just happy_var_1
	)}

happyReduce_49 = happySpecReduce_0  23# happyReduction_49
happyReduction_49  =  happyIn28
		 (Nothing
	)

happyReduce_50 = happySpecReduce_1  24# happyReduction_50
happyReduction_50 happy_x_1
	 =  happyIn29
		 (BTstring
	)

happyReduce_51 = happySpecReduce_1  24# happyReduction_51
happyReduction_51 happy_x_1
	 =  happyIn29
		 (BTbinary
	)

happyReduce_52 = happySpecReduce_1  24# happyReduction_52
happyReduction_52 happy_x_1
	 =  happyIn29
		 (BTbool
	)

happyReduce_53 = happySpecReduce_1  24# happyReduction_53
happyReduction_53 happy_x_1
	 =  happyIn29
		 (BTint
	)

happyReduce_54 = happySpecReduce_1  24# happyReduction_54
happyReduction_54 happy_x_1
	 =  happyIn29
		 (BTutc
	)

happyReduce_55 = happySpecReduce_1  25# happyReduction_55
happyReduction_55 happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	happyIn30
		 (FieldName happy_var_1
	)}

happyReduce_56 = happySpecReduce_1  26# happyReduction_56
happyReduction_56 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (VarIden  happy_var_1)) -> 
	happyIn31
		 (happy_var_1
	)}

happyReduce_57 = happySpecReduce_1  26# happyReduction_57
happyReduction_57 happy_x_1
	 =  happyIn31
		 ("default"
	)

happyReduce_58 = happySpecReduce_1  26# happyReduction_58
happyReduction_58 happy_x_1
	 =  happyIn31
		 ("field"
	)

happyReduce_59 = happySpecReduce_1  26# happyReduction_59
happyReduction_59 happy_x_1
	 =  happyIn31
		 ("alternative"
	)

happyReduce_60 = happySpecReduce_1  26# happyReduction_60
happyReduction_60 happy_x_1
	 =  happyIn31
		 ("to"
	)

happyReduce_61 = happySpecReduce_1  27# happyReduction_61
happyReduction_61 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (TypeIden happy_var_1)) -> 
	happyIn32
		 (TypeName happy_var_1
	)}

happyReduce_62 = happyReduce 5# 28# happyReduction_62
happyReduction_62 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut35 happy_x_2 of { happy_var_2 -> 
	case happyOut36 happy_x_3 of { happy_var_3 -> 
	case happyOut33 happy_x_5 of { happy_var_5 -> 
	happyIn33
		 (ChangesUpTo happy_var_2 happy_var_3 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_63 = happySpecReduce_2  28# happyReduction_63
happyReduction_63 happy_x_2
	happy_x_1
	 =  case happyOut34 happy_x_2 of { happy_var_2 -> 
	happyIn33
		 (ChangesStart happy_var_2
	)}

happyReduce_64 = happySpecReduce_3  28# happyReduction_64
happyReduction_64 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut33 happy_x_3 of { happy_var_3 -> 
	happyIn33
		 (happy_var_3
	)}

happyReduce_65 = happySpecReduce_1  29# happyReduction_65
happyReduction_65 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (Strg     happy_var_1)) -> 
	happyIn34
		 (parseVer happy_var_1
	)}

happyReduce_66 = happySpecReduce_1  30# happyReduction_66
happyReduction_66 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (Strg     happy_var_1)) -> 
	happyIn35
		 (parseVersionExtra happy_var_1
	)}

happyReduce_67 = happySpecReduce_1  31# happyReduction_67
happyReduction_67 happy_x_1
	 =  case happyOut37 happy_x_1 of { happy_var_1 -> 
	happyIn36
		 (concat (reverse happy_var_1)
	)}

happyReduce_68 = happySpecReduce_2  32# happyReduction_68
happyReduction_68 happy_x_2
	happy_x_1
	 =  case happyOut37 happy_x_1 of { happy_var_1 -> 
	case happyOut38 happy_x_2 of { happy_var_2 -> 
	happyIn37
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_69 = happySpecReduce_0  32# happyReduction_69
happyReduction_69  =  happyIn37
		 ([]
	)

happyReduce_70 = happySpecReduce_3  33# happyReduction_70
happyReduction_70 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut32 happy_x_2 of { happy_var_2 -> 
	case happyOut10 happy_x_3 of { happy_var_3 -> 
	happyIn38
		 ([ChAddType happy_var_2 (declNF happy_var_3)]
	)}}

happyReduce_71 = happySpecReduce_2  33# happyReduction_71
happyReduction_71 happy_x_2
	happy_x_1
	 =  case happyOut32 happy_x_2 of { happy_var_2 -> 
	happyIn38
		 ([ChDeleteType happy_var_2]
	)}

happyReduce_72 = happyReduce 4# 33# happyReduction_72
happyReduction_72 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut32 happy_x_2 of { happy_var_2 -> 
	case happyOut32 happy_x_4 of { happy_var_4 -> 
	happyIn38
		 ([ChRenameType happy_var_2 happy_var_4]
	) `HappyStk` happyRest}}

happyReduce_73 = happyReduce 4# 33# happyReduction_73
happyReduction_73 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut32 happy_x_3 of { happy_var_3 -> 
	case happyOut39 happy_x_4 of { happy_var_4 -> 
	happyIn38
		 (map (fldChangeToAPIChange happy_var_3)   (reverse happy_var_4)
	) `HappyStk` happyRest}}

happyReduce_74 = happyReduce 4# 33# happyReduction_74
happyReduction_74 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut32 happy_x_3 of { happy_var_3 -> 
	case happyOut43 happy_x_4 of { happy_var_4 -> 
	happyIn38
		 (map (unionChangeToAPIChange happy_var_3) (reverse happy_var_4)
	) `HappyStk` happyRest}}

happyReduce_75 = happyReduce 4# 33# happyReduction_75
happyReduction_75 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut32 happy_x_3 of { happy_var_3 -> 
	case happyOut45 happy_x_4 of { happy_var_4 -> 
	happyIn38
		 (map (enumChangeToAPIChange happy_var_3)  (reverse happy_var_4)
	) `HappyStk` happyRest}}

happyReduce_76 = happyReduce 4# 33# happyReduction_76
happyReduction_76 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut32 happy_x_3 of { happy_var_3 -> 
	case happyOut47 happy_x_4 of { happy_var_4 -> 
	happyIn38
		 ([ChCustomType happy_var_3 happy_var_4]
	) `HappyStk` happyRest}}

happyReduce_77 = happySpecReduce_2  33# happyReduction_77
happyReduction_77 happy_x_2
	happy_x_1
	 =  case happyOut47 happy_x_2 of { happy_var_2 -> 
	happyIn38
		 ([ChCustomAll happy_var_2]
	)}

happyReduce_78 = happySpecReduce_1  33# happyReduction_78
happyReduction_78 happy_x_1
	 =  happyIn38
		 ([]
	)

happyReduce_79 = happySpecReduce_2  34# happyReduction_79
happyReduction_79 happy_x_2
	happy_x_1
	 =  case happyOut39 happy_x_1 of { happy_var_1 -> 
	case happyOut40 happy_x_2 of { happy_var_2 -> 
	happyIn39
		 (happy_var_2 ++ happy_var_1
	)}}

happyReduce_80 = happySpecReduce_1  34# happyReduction_80
happyReduction_80 happy_x_1
	 =  case happyOut40 happy_x_1 of { happy_var_1 -> 
	happyIn39
		 (happy_var_1
	)}

happyReduce_81 = happyReduce 6# 35# happyReduction_81
happyReduction_81 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut30 happy_x_3 of { happy_var_3 -> 
	case happyOut27 happy_x_5 of { happy_var_5 -> 
	case happyOut41 happy_x_6 of { happy_var_6 -> 
	happyIn40
		 ([FldChAdd happy_var_3 happy_var_5 happy_var_6]
	) `HappyStk` happyRest}}}

happyReduce_82 = happySpecReduce_3  35# happyReduction_82
happyReduction_82 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_3 of { happy_var_3 -> 
	happyIn40
		 ([FldChDelete happy_var_3]
	)}

happyReduce_83 = happyReduce 5# 35# happyReduction_83
happyReduction_83 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut30 happy_x_3 of { happy_var_3 -> 
	case happyOut30 happy_x_5 of { happy_var_5 -> 
	happyIn40
		 ([FldChRename happy_var_3 happy_var_5]
	) `HappyStk` happyRest}}

happyReduce_84 = happyReduce 7# 35# happyReduction_84
happyReduction_84 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut30 happy_x_3 of { happy_var_3 -> 
	case happyOut27 happy_x_5 of { happy_var_5 -> 
	case happyOut47 happy_x_7 of { happy_var_7 -> 
	happyIn40
		 ([FldChChange happy_var_3 happy_var_5 happy_var_7]
	) `HappyStk` happyRest}}}

happyReduce_85 = happySpecReduce_1  35# happyReduction_85
happyReduction_85 happy_x_1
	 =  happyIn40
		 ([]
	)

happyReduce_86 = happySpecReduce_2  36# happyReduction_86
happyReduction_86 happy_x_2
	happy_x_1
	 =  case happyOut42 happy_x_2 of { happy_var_2 -> 
	happyIn41
		 (Just happy_var_2
	)}

happyReduce_87 = happySpecReduce_0  36# happyReduction_87
happyReduction_87  =  happyIn41
		 (Nothing
	)

happyReduce_88 = happySpecReduce_2  37# happyReduction_88
happyReduction_88 happy_x_2
	happy_x_1
	 =  happyIn42
		 (DefValList
	)

happyReduce_89 = happySpecReduce_1  37# happyReduction_89
happyReduction_89 happy_x_1
	 =  happyIn42
		 (DefValMaybe
	)

happyReduce_90 = happySpecReduce_1  37# happyReduction_90
happyReduction_90 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (Strg     happy_var_1)) -> 
	happyIn42
		 (DefValString (T.pack happy_var_1)
	)}

happyReduce_91 = happySpecReduce_1  37# happyReduction_91
happyReduction_91 happy_x_1
	 =  happyIn42
		 (DefValBool True
	)

happyReduce_92 = happySpecReduce_1  37# happyReduction_92
happyReduction_92 happy_x_1
	 =  happyIn42
		 (DefValBool False
	)

happyReduce_93 = happySpecReduce_1  37# happyReduction_93
happyReduction_93 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (Intg     happy_var_1)) -> 
	happyIn42
		 (DefValInt happy_var_1
	)}

happyReduce_94 = happySpecReduce_1  37# happyReduction_94
happyReduction_94 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (UTCTIME  happy_var_1)) -> 
	happyIn42
		 (DefValUtc happy_var_1
	)}

happyReduce_95 = happySpecReduce_2  38# happyReduction_95
happyReduction_95 happy_x_2
	happy_x_1
	 =  case happyOut43 happy_x_1 of { happy_var_1 -> 
	case happyOut44 happy_x_2 of { happy_var_2 -> 
	happyIn43
		 (happy_var_2 ++ happy_var_1
	)}}

happyReduce_96 = happySpecReduce_1  38# happyReduction_96
happyReduction_96 happy_x_1
	 =  case happyOut44 happy_x_1 of { happy_var_1 -> 
	happyIn43
		 (happy_var_1
	)}

happyReduce_97 = happyReduce 5# 39# happyReduction_97
happyReduction_97 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut30 happy_x_3 of { happy_var_3 -> 
	case happyOut27 happy_x_5 of { happy_var_5 -> 
	happyIn44
		 ([UnChAdd happy_var_3 happy_var_5]
	) `HappyStk` happyRest}}

happyReduce_98 = happySpecReduce_3  39# happyReduction_98
happyReduction_98 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_3 of { happy_var_3 -> 
	happyIn44
		 ([UnChDelete happy_var_3]
	)}

happyReduce_99 = happyReduce 5# 39# happyReduction_99
happyReduction_99 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut30 happy_x_3 of { happy_var_3 -> 
	case happyOut30 happy_x_5 of { happy_var_5 -> 
	happyIn44
		 ([UnChRename happy_var_3 happy_var_5]
	) `HappyStk` happyRest}}

happyReduce_100 = happySpecReduce_1  39# happyReduction_100
happyReduction_100 happy_x_1
	 =  happyIn44
		 ([]
	)

happyReduce_101 = happySpecReduce_2  40# happyReduction_101
happyReduction_101 happy_x_2
	happy_x_1
	 =  case happyOut45 happy_x_1 of { happy_var_1 -> 
	case happyOut46 happy_x_2 of { happy_var_2 -> 
	happyIn45
		 (happy_var_2 ++ happy_var_1
	)}}

happyReduce_102 = happySpecReduce_1  40# happyReduction_102
happyReduction_102 happy_x_1
	 =  case happyOut46 happy_x_1 of { happy_var_1 -> 
	happyIn45
		 (happy_var_1
	)}

happyReduce_103 = happySpecReduce_3  41# happyReduction_103
happyReduction_103 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_3 of { happy_var_3 -> 
	happyIn46
		 ([EnChAdd happy_var_3]
	)}

happyReduce_104 = happySpecReduce_3  41# happyReduction_104
happyReduction_104 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_3 of { happy_var_3 -> 
	happyIn46
		 ([EnChDelete happy_var_3]
	)}

happyReduce_105 = happyReduce 5# 41# happyReduction_105
happyReduction_105 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut30 happy_x_3 of { happy_var_3 -> 
	case happyOut30 happy_x_5 of { happy_var_5 -> 
	happyIn46
		 ([EnChRename happy_var_3 happy_var_5]
	) `HappyStk` happyRest}}

happyReduce_106 = happySpecReduce_1  41# happyReduction_106
happyReduction_106 happy_x_1
	 =  happyIn46
		 ([]
	)

happyReduce_107 = happySpecReduce_1  42# happyReduction_107
happyReduction_107 happy_x_1
	 =  case happyOutTok happy_x_1 of { ((,) _ (TypeIden happy_var_1)) -> 
	happyIn47
		 (happy_var_1
	)}

happyNewToken action sts stk [] =
	happyDoAction 43# notHappyAtAll action sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = happyDoAction i tk action sts stk tks in
	case tk of {
	(,) _ Semi -> cont 1#;
	(,) _ Bar -> cont 2#;
	(,) _ Bra -> cont 3#;
	(,) _ Ket -> cont 4#;
	(,) _ ColCol -> cont 5#;
	(,) _ Equals -> cont 6#;
	(,) _ Query -> cont 7#;
	(,) _ Comma -> cont 8#;
	(,) _ LtEq -> cont 9#;
	(,) _ GtEq -> cont 10#;
	(,) _ Version -> cont 11#;
	(,) _ With -> cont 12#;
	(,) _ Integer -> cont 13#;
	(,) _ Boolean -> cont 14#;
	(,) _ UTC -> cont 15#;
	(,) _ String -> cont 16#;
	(,) _ BInary -> cont 17#;
	(,) _ Json -> cont 18#;
	(,) _ Record -> cont 19#;
	(,) _ Union -> cont 20#;
	(,) _ Enum -> cont 21#;
	(,) _ Basic -> cont 22#;
	(,) _ Changes -> cont 23#;
	(,) _ Added -> cont 24#;
	(,) _ Removed -> cont 25#;
	(,) _ Renamed -> cont 26#;
	(,) _ Changed -> cont 27#;
	(,) _ Default -> cont 28#;
	(,) _ Field -> cont 29#;
	(,) _ Alternative -> cont 30#;
	(,) _ Migration -> cont 31#;
	(,) _ To -> cont 32#;
	(,) _ NOTHING -> cont 33#;
	(,) _ Readonly -> cont 34#;
	(,) _ (Comment  happy_dollar_dollar) -> cont 35#;
	(,) _ (TypeIden happy_dollar_dollar) -> cont 36#;
	(,) _ (VarIden  happy_dollar_dollar) -> cont 37#;
	(,) _ (Intg     happy_dollar_dollar) -> cont 38#;
	(,) _ (Strg     happy_dollar_dollar) -> cont 39#;
	(,) _ TRUE -> cont 40#;
	(,) _ FALSE -> cont 41#;
	(,) _ (UTCTIME  happy_dollar_dollar) -> cont 42#;
	_ -> happyError' (tk:tks)
	}

happyError_ 43# tk tks = happyError' tks
happyError_ _ tk tks = happyError' (tk:tks)

happyThen :: () => ParseM a -> (a -> ParseM b) -> ParseM b
happyThen = (>>=)
happyReturn :: () => a -> ParseM a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> ParseM a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [(PToken)] -> ParseM a
happyError' = happyError

parse tks = happySomeParser where
  happySomeParser = happyThen (happyParse 0# tks) (\x -> happyReturn (happyOut6 x))

parse_with_changelog tks = happySomeParser where
  happySomeParser = happyThen (happyParse 1# tks) (\x -> happyReturn (happyOut5 x))

happySeq = happyDontSeq


type ParseM = Either [PToken]

happyError :: [PToken] -> ParseM a
happyError = Left

parseAPI :: String -> (Int, Int) -> String -> API
parseAPI = wrap parse

wrap :: ([PToken] -> ParseM a) -> String -> (Int, Int) -> String -> a
wrap parser fn (start_ln,_start_cn) s = case parser (scan s) of
    Right v  -> v
    Left tks -> error $ printf "Syntax error at %s of %s:\n        %s\n" (loc tks) fn $ show (take 5 tks)
  where
    loc tks = case tks of
            []                    -> "<EOF>"
            (AlexPn ad ln cn,_):_ -> printf "line %d, column %d (@%d)" (start_ln+ln-1) (cn-1) ad

parseAPIWithChangelog :: String -> (Int, Int) -> String -> APIWithChangelog
parseAPIWithChangelog = wrap parse_with_changelog


data FieldChange = FldChAdd FieldName APIType (Maybe DefaultValue)
                 | FldChDelete FieldName
                 | FldChRename FieldName FieldName
                 | FldChChange FieldName APIType MigrationTag

fldChangeToAPIChange :: TypeName -> FieldChange -> APIChange
fldChangeToAPIChange t (FldChAdd f ty def)  = ChAddField t f ty def
fldChangeToAPIChange t (FldChDelete f)      = ChDeleteField t f
fldChangeToAPIChange t (FldChRename f f')   = ChRenameField t f f'
fldChangeToAPIChange t (FldChChange f ty m) = ChChangeField t f ty m

data UnionChange = UnChAdd FieldName APIType
                 | UnChDelete FieldName
                 | UnChRename FieldName FieldName

unionChangeToAPIChange :: TypeName -> UnionChange -> APIChange
unionChangeToAPIChange t (UnChAdd f ty)    = ChAddUnionAlt t f ty
unionChangeToAPIChange t (UnChDelete f)    = ChDeleteUnionAlt t f
unionChangeToAPIChange t (UnChRename f f') = ChRenameUnionAlt t f f'

data EnumChange = EnChAdd FieldName
                | EnChDelete FieldName
                | EnChRename FieldName FieldName

enumChangeToAPIChange :: TypeName -> EnumChange -> APIChange
enumChangeToAPIChange t (EnChAdd f)       = ChAddEnumVal t f
enumChangeToAPIChange t (EnChDelete f)    = ChDeleteEnumVal t f
enumChangeToAPIChange t (EnChRename f f') = ChRenameEnumVal t f f'


parseVer :: String -> V.Version
parseVer x = case simpleParse x of
                 Just v -> v
                 Nothing -> error $ "Syntax error while parsing version " ++ x

parseVersionExtra :: String -> VersionExtra
parseVersionExtra "development" = DevVersion
parseVersionExtra s             = Release $ parseVer s


api :: QuasiQuoter
api =
    QuasiQuoter
        { quoteExp  = located [|parseAPI|]
        , quotePat  = error "api QuasiQuoter used in patten      context"
        , quoteType = error "api QuasiQuoter used in type        context"
        , quoteDec  = error "api QuasiQuoter used in declaration context"
        }

apiWithChangelog :: QuasiQuoter
apiWithChangelog =
    QuasiQuoter
        { quoteExp  = located [|parseAPIWithChangelog|]
        , quotePat  = error "apiWithChangelog QuasiQuoter used in patten      context"
        , quoteType = error "apiWithChangelog QuasiQuoter used in type        context"
        , quoteDec  = error "apiWithChangelog QuasiQuoter used in declaration context"
        }

located :: ExpQ -> String -> ExpQ
located e s = do
    l <- location
    let fn = loc_filename l
        ls = loc_start    l
    [|$(e) fn ls s|]
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 10 "<command-line>" #-}
# 1 "/usr/include/stdc-predef.h" 1 3 4

# 17 "/usr/include/stdc-predef.h" 3 4














# 1 "/usr/include/x86_64-linux-gnu/bits/predefs.h" 1 3 4

# 18 "/usr/include/x86_64-linux-gnu/bits/predefs.h" 3 4












# 31 "/usr/include/stdc-predef.h" 2 3 4








{-# LINE 10 "<command-line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 13 "templates/GenericTemplate.hs" #-}





-- Do not remove this comment. Required to fix CPP parsing when using GCC and a clang-compiled alex.
#if __GLASGOW_HASKELL__ > 706
#define LT(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.<# m)) :: Bool)
#define GTE(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.>=# m)) :: Bool)
#define EQ(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.==# m)) :: Bool)
#else
#define LT(n,m) (n Happy_GHC_Exts.<# m)
#define GTE(n,m) (n Happy_GHC_Exts.>=# m)
#define EQ(n,m) (n Happy_GHC_Exts.==# m)
#endif
{-# LINE 46 "templates/GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Happy_GHC_Exts.Int# Happy_IntList





{-# LINE 67 "templates/GenericTemplate.hs" #-}

{-# LINE 77 "templates/GenericTemplate.hs" #-}

{-# LINE 86 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
        happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
        (happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
        = {- nothing -}


          case action of
                0#           -> {- nothing -}
                                     happyFail i tk st
                -1#          -> {- nothing -}
                                     happyAccept i tk st
                n | LT(n,(0# :: Happy_GHC_Exts.Int#)) -> {- nothing -}

                                                   (happyReduceArr Happy_Data_Array.! rule) i tk st
                                                   where rule = (Happy_GHC_Exts.I# ((Happy_GHC_Exts.negateInt# ((n Happy_GHC_Exts.+# (1# :: Happy_GHC_Exts.Int#))))))
                n                 -> {- nothing -}


                                     happyShift new_state i tk st
                                     where new_state = (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#))
   where off    = indexShortOffAddr happyActOffsets st
         off_i  = (off Happy_GHC_Exts.+# i)
         check  = if GTE(off_i,(0# :: Happy_GHC_Exts.Int#))
                  then EQ(indexShortOffAddr happyCheck off_i, i)
                  else False
         action
          | check     = indexShortOffAddr happyTable off_i
          | otherwise = indexShortOffAddr happyDefActions st


indexShortOffAddr (HappyA# arr) off =
        Happy_GHC_Exts.narrow16Int# i
  where
        i = Happy_GHC_Exts.word2Int# (Happy_GHC_Exts.or# (Happy_GHC_Exts.uncheckedShiftL# high 8#) low)
        high = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr (off' Happy_GHC_Exts.+# 1#)))
        low  = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr off'))
        off' = off Happy_GHC_Exts.*# 2#





data HappyAddr = HappyA# Happy_GHC_Exts.Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 170 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) sts of
         sts1@((HappyCons (st1@(action)) (_))) ->
                let r = fn stk in  -- it doesn't hurt to always seq here...
                happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
          let drop_stk = happyDropStk k stk in
          happyThen1 (fn stk tk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))

happyMonad2Reduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
         let drop_stk = happyDropStk k stk

             off = indexShortOffAddr happyGotoOffsets st1
             off_i = (off Happy_GHC_Exts.+# nt)
             new_state = indexShortOffAddr happyTable off_i



          in
          happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))

happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n Happy_GHC_Exts.-# (1#::Happy_GHC_Exts.Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off = indexShortOffAddr happyGotoOffsets st
         off_i = (off Happy_GHC_Exts.+# nt)
         new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail 0# tk old_st _ stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--      trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
                                                (saved_tok `HappyStk` _ `HappyStk` stk) =
--      trace ("discarding state, depth " ++ show (length stk))  $
        happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
        happyDoAction 0# tk action sts ( (Happy_GHC_Exts.unsafeCoerce# (Happy_GHC_Exts.I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Happy_GHC_Exts.Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--      happySeq = happyDoSeq
-- otherwise it emits
--      happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
